module Core.Mongo ( mongoSetup ) where

import Core.Types

import Control.Monad.Reader (MonadIO, lift, ask)
import Data.Maybe
import Data.Text            (Text)
import Database.MongoDB
import Prelude

-- Authenticates to Mongo and returns the MongoContext for the dataDB
mongoSetup :: DhallConfig -> IO MongoContext
mongoSetup conf = do
  mongoCon     <- connect $ host (hostname conf)
  let adminCon  = MongoContext mongoCon master (adminDB conf)
  access 
    (mongoPipe       adminCon) 
    (mongoAccessMode adminCon) 
    (mongoDatabase   adminCon) 
    (auth (mongoUsername conf) (mongoPassword conf))
  return $ MongoContext mongoCon master (dataDB conf)
