{-# LANGUAGE QuasiQuotes #-}
{-# LANGUAGE TemplateHaskell #-}

module Core.Templates ( renderIndex, renderStyle ) where

import Data.Text.Lazy                (Text)
import Database.MongoDB              (Document)
import Text.Blaze.Html.Renderer.Text (renderHtml)
import Text.Blaze.Html
import Text.Cassius                  (cassiusFile, renderCss)
import Text.Hamlet                   (shamletFile)

import Prelude 

renderIndex :: String -> Maybe String -> Text
renderIndex link password = renderHtml ( $(shamletFile "./views/index.hamlet") )

renderStyle :: Text
renderStyle = renderCss ( $(cassiusFile "./views/cassius/style.cassius") "/style.css" )
