module Feature.Sharing.HTTP ( routes ) where

import Core.Types
import Core.Templates (renderIndex)

import           Feature.Sharing.Templates (renderPw)
import qualified Feature.Sharing.Mongo     as DB

import qualified Data.Text      as T
import qualified Data.Text.Lazy as LT

import Control.Monad.Reader (ask, lift)
import Data.AesonBson       (aesonify)
import Data.Bson            (Document, Field (..), Value (..), lookup)
import Web.Scotty.Trans 
import Prelude              hiding (lookup)

routes :: PurrApp ()
routes = do 

  get "/pw/:id" $ do
    reqId  <- param "id"
    doc    <- DB.findByLink reqId
    html    $ renderIndex reqId (pwLookup doc)

  post "/pw" $ do
    reqId  <- param "userLink"
    doc    <- DB.findByLink reqId
    html    $ renderPw reqId (pwLookup doc)

pwLookup :: Maybe Document -> Maybe String
pwLookup (Just x) = lookup "password" x
pwLookup _        = Nothing
